Overview | Package | Class | Tree | Serialized | Deprecated | Index | Help
| OSGi Service Platform Release 3
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.osgi.framework
Interface BundleActivator

All Known Implementing Classes:
  XMLParserActivator

public interface BundleActivator

Customizes the starting and stopping of this bundle.

`BundleActivator` is an interface that may be implemented when this bundle is started or stopped. The Framework can create instances of this bundle's `BundleActivator` as required. If an instance's `BundleActivator.start` method executes successfully, it is guaranteed that the same instance's `BundleActivator.stop` method will be called when this bundle is to be stopped.

`BundleActivator` is specified through the `Bundle-Activator` Manifest header. A bundle can only specify a single `BundleActivator` in the Manifest file. The form of the Manifest header is:

     Bundle-Activator: class-name

where `class-name` is a fully qualified Java classname.

The specified `BundleActivator` class must have a public constructor that takes no parameters so that a `BundleActivator` object can be created by `Class.newInstance()`.

Method Summary
`void` | `start(BundleContext context)` Called when this bundle is started so the Framework can perform the bundle-specific activities necessary to start this bundle.
`void` | `stop(BundleContext context)` Called when this bundle is stopped so the Framework can perform the bundle-specific activities necessary to stop the bundle.

Method Detail

### start

    public void start(BundleContext context)
               throws java.lang.Exception

  Called when this bundle is started so the Framework can perform the bundle-specific activities necessary to start this bundle. This method can be used to register services or to allocate any resources that this bundle needs.

  This method must complete and return to its caller in a timely manner.

  Parameters:
    `context` - The execution context of the bundle being started.
  Throws:
    `java.lang.Exception` - If this method throws an exception, this bundle is marked as stopped and the Framework will remove this bundle's listeners, unregister all services registered by this bundle, and release all services used by this bundle.
  See Also:
    `Bundle.start()`

### stop

    public void stop(BundleContext context)
              throws java.lang.Exception

  Called when this bundle is stopped so the Framework can perform the bundle-specific activities necessary to stop the bundle. In general, this method should undo the work that the `BundleActivator.start` method started. There should be no active threads that were started by this bundle when this bundle returns. A stopped bundle should be stopped and should not call any Framework objects.

  This method must complete and return to its caller in a timely manner.

  Parameters:
    `context` - The execution context of the bundle being stopped.
  Throws:
    `java.lang.Exception` - If this method throws an exception, the bundle is still marked as stopped, and the Framework will remove the bundle's listeners, unregister all services registered by the bundle, and release all services used by the bundle.
  See Also:
    `Bundle.stop()`

Overview | Package | Class | Tree | Serialized | Deprecated | Index | Help
| OSGi Service Platform Release 3
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) OSGi Alliance (2000, 2003). All Rights Reserved.